/*	
 *	d12sys.h
 *
 *	PDIUSBD12 VXevO
 *	Copyright (c) 1997 Philips Semiconductors
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Aug 16 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __D12SYS_H__
#define __D12SYS_H__

/****************************************************************************
 *	萔E^
 ****************************************************************************/

/* foCXNGXg\
 * * ڍׂUSBdlQƂĂB
 */
typedef struct _DEVICE_REQUEST {
	unsigned char bmRequestType;
	unsigned char bRequest;
	unsigned short wValue;
	unsigned short wIndex;
	unsigned short wLength;
} DEVICE_REQUEST;

/* USBtbN
 * * usb_hook()ւ̈Ƃėp܂B
 *   mode͕Kݒ肵ĂBiʏ 0x00:NONISO Ȃ̂ŁA[NAłłj
 *   Cxg/NGXgnh͎ĝݒ肵AgȂ̂NULLɂĂB
 */
typedef struct _USBINFO {
	/* USBC mode */
	int mode;			/* USBC[h(D12_ENDP_NONISO/ISOOUT/ISOIN/ISOIO) */
	/* USBC raw event */
	void (*bus_reset)();		/* oXZbgCxg */
	void (*ep1_rxdone)(int st);	/* EP1MCxg  */
	void (*ep1_txdone)(int st);	/* EP1MCxg  */
	void (*ep2_rxdone)(int st);	/* EP2MCxg  */
	void (*ep2_txdone)(int st);	/* EP2MCxg  */
	/* Device request */
	void (*standard_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
	void (*class_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
	void (*vendor_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
} USBINFO;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

/* USBRg[̐tbN܂B
 * [in]
 *	ui	USBtbNւ̃|C^
 *		usb_hook()̓|C^̎weRs[ĕێ܂B
 *		֐ԂAJĂ܂Ă\܂B
 * [note]
 *	* ɃtbNĂꍇ́AIɂtbNĂtbN܂B
 *	  ]āAusb_hook()֐͏ɐ܂B
 */
void usb_hook(const USBINFO* ui);

/* USBRg[̐tbN܂B
 * [note]
 *	* ܂tbNĂȂꍇ́Å֐͉܂B
 */
void usb_unhook();

/* Gh|Cg0 IN/OUT Xg[܂B
 */
void usb_ep0_stall();

/* Gh|Cg0 IN(foCXzXg) gāAf[^𑗐M܂B
 * [in]
 *	ptr	Mf[^̐擪AhX
 *	len	Mf[^̃oCg
 * [out]
 *	* ̊֐́AfoCXNGXgւ̉ƂĂ̂ݗpł܂B
 *	  USBINFO\̂Ɏw肵foCXNGXgnhR[obNꂽɁA
 *	  R[obN̒炾p\łB̓IȗpŕÂƂłB
 *	  - GETNGXgɑ΂Rg[f[^ԐM
 *	  - SETNGXgɑ΂Xe[^X(pPbg)ԐM
 *	  ȊO̖ړIE^C~OŗpƁA\łȂʂƂȂ܂B
 *	* M͔񓯊ɍs܂B
 *	  M܂ŁAptr̎wf[^QƂꑱ܂B
 *	  f[^J/ύXȂ悤CĂB
 *	  ̃foCXNGXgMAf[^J/ύXĂSłB
 */
void usb_ep0_tx(const char* ptr, int len);

#endif /*__D12SYS_H__*/
